#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_BUFFER_DEVICE_ADDRESS_SPEC_VERSION")]
pub const KHR_BUFFER_DEVICE_ADDRESS_SPEC_VERSION: u32 = 1;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME")]
pub const KHR_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_KHR_buffer_device_address");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_BUFFER_OPAQUE_CAPTURE_ADDRESS_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetBufferOpaqueCaptureAddressKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_BUFFER_DEVICE_ADDRESS_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetBufferDeviceAddressKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_DEVICE_MEMORY_OPAQUE_CAPTURE_ADDRESS_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetDeviceMemoryOpaqueCaptureAddressKHR");
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceBufferDeviceAddressFeaturesKHR.html)) · Alias <br/> VkPhysicalDeviceBufferDeviceAddressFeatures - Structure describing buffer address features that can be supported by an implementation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceBufferDeviceAddressFeatures`] structure is defined\nas:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkPhysicalDeviceBufferDeviceAddressFeatures {\n    VkStructureType    sType;\n    void*              pNext;\n    VkBool32           bufferDeviceAddress;\n    VkBool32           bufferDeviceAddressCaptureReplay;\n    VkBool32           bufferDeviceAddressMultiDevice;\n} VkPhysicalDeviceBufferDeviceAddressFeatures;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_buffer_device_address\ntypedef VkPhysicalDeviceBufferDeviceAddressFeatures VkPhysicalDeviceBufferDeviceAddressFeaturesKHR;\n```\n[](#_members)Members\n----------\n\nThis structure describes the following features:\n[](#_description)Description\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* []()`bufferDeviceAddress` indicates that the implementation supports\n  accessing buffer memory in shaders as storage buffers via an address\n  queried from [`crate::vk::PFN_vkGetBufferDeviceAddress`].\n\n* []()`bufferDeviceAddressCaptureReplay` indicates that the implementation\n  supports saving and reusing buffer and device addresses, e.g. for trace\n  capture and replay.\n\n* []()`bufferDeviceAddressMultiDevice` indicates that the implementation\n  supports the `bufferDeviceAddress`, `rayTracingPipeline` and `rayQuery` features\n  for logical devices created with multiple physical devices.\n  If this feature is not supported, buffer\n  and acceleration structure\n  addresses **must** not be queried on a logical device created with more\n  than one physical device.\n\n|   |Note<br/><br/>`bufferDeviceAddressMultiDevice` exists to allow certain legacy<br/>platforms to be able to support `bufferDeviceAddress` without needing to<br/>support shared GPU virtual addresses for multi-device configurations.|\n|---|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nSee [`crate::vk::PFN_vkGetBufferDeviceAddress`] for more information.\n\nIf the [`crate::vk::PhysicalDeviceBufferDeviceAddressFeatures`] structure is included in the `pNext` chain of the[`crate::vk::PhysicalDeviceFeatures2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceFeatures2`], it is filled in to indicate whether each\ncorresponding feature is supported.[`crate::vk::PhysicalDeviceBufferDeviceAddressFeatures`] **can** also be used in the `pNext` chain of[`crate::vk::DeviceCreateInfo`] to selectively enable these features.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceBufferDeviceAddressFeatures-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_BUFFER_DEVICE_ADDRESS_FEATURES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceBufferDeviceAddressFeaturesKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceBufferDeviceAddressFeaturesKHR = crate::vk1_2::PhysicalDeviceBufferDeviceAddressFeatures;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceBufferDeviceAddressFeaturesKHR.html)) · Alias <br/> VkPhysicalDeviceBufferDeviceAddressFeatures - Structure describing buffer address features that can be supported by an implementation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceBufferDeviceAddressFeatures`] structure is defined\nas:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkPhysicalDeviceBufferDeviceAddressFeatures {\n    VkStructureType    sType;\n    void*              pNext;\n    VkBool32           bufferDeviceAddress;\n    VkBool32           bufferDeviceAddressCaptureReplay;\n    VkBool32           bufferDeviceAddressMultiDevice;\n} VkPhysicalDeviceBufferDeviceAddressFeatures;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_buffer_device_address\ntypedef VkPhysicalDeviceBufferDeviceAddressFeatures VkPhysicalDeviceBufferDeviceAddressFeaturesKHR;\n```\n[](#_members)Members\n----------\n\nThis structure describes the following features:\n[](#_description)Description\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* []()`bufferDeviceAddress` indicates that the implementation supports\n  accessing buffer memory in shaders as storage buffers via an address\n  queried from [`crate::vk::PFN_vkGetBufferDeviceAddress`].\n\n* []()`bufferDeviceAddressCaptureReplay` indicates that the implementation\n  supports saving and reusing buffer and device addresses, e.g. for trace\n  capture and replay.\n\n* []()`bufferDeviceAddressMultiDevice` indicates that the implementation\n  supports the `bufferDeviceAddress`, `rayTracingPipeline` and `rayQuery` features\n  for logical devices created with multiple physical devices.\n  If this feature is not supported, buffer\n  and acceleration structure\n  addresses **must** not be queried on a logical device created with more\n  than one physical device.\n\n|   |Note<br/><br/>`bufferDeviceAddressMultiDevice` exists to allow certain legacy<br/>platforms to be able to support `bufferDeviceAddress` without needing to<br/>support shared GPU virtual addresses for multi-device configurations.|\n|---|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nSee [`crate::vk::PFN_vkGetBufferDeviceAddress`] for more information.\n\nIf the [`crate::vk::PhysicalDeviceBufferDeviceAddressFeatures`] structure is included in the `pNext` chain of the[`crate::vk::PhysicalDeviceFeatures2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceFeatures2`], it is filled in to indicate whether each\ncorresponding feature is supported.[`crate::vk::PhysicalDeviceBufferDeviceAddressFeatures`] **can** also be used in the `pNext` chain of[`crate::vk::DeviceCreateInfo`] to selectively enable these features.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceBufferDeviceAddressFeatures-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_BUFFER_DEVICE_ADDRESS_FEATURES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceBufferDeviceAddressFeaturesKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceBufferDeviceAddressFeaturesKHRBuilder<'a> = crate::vk1_2::PhysicalDeviceBufferDeviceAddressFeaturesBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferDeviceAddressInfoKHR.html)) · Alias <br/> VkBufferDeviceAddressInfo - Structure specifying the buffer to query an address for\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::BufferDeviceAddressInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkBufferDeviceAddressInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkBuffer           buffer;\n} VkBufferDeviceAddressInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_buffer_device_address\ntypedef VkBufferDeviceAddressInfo VkBufferDeviceAddressInfoKHR;\n```\n\nor the equivalent\n\n```\n// Provided by VK_EXT_buffer_device_address\ntypedef VkBufferDeviceAddressInfo VkBufferDeviceAddressInfoEXT;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `buffer` specifies the buffer whose address is being queried.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkBufferDeviceAddressInfo-buffer-02600  \n   If `buffer` is non-sparse and was not created with the[`crate::vk::BufferCreateFlagBits::DEVICE_ADDRESS_CAPTURE_REPLAY`] flag, then it**must** be bound completely and contiguously to a single[`crate::vk::DeviceMemory`] object\n\n* []() VUID-VkBufferDeviceAddressInfo-buffer-02601  \n  `buffer` **must** have been created with[`crate::vk::BufferUsageFlagBits::SHADER_DEVICE_ADDRESS`]\n\nValid Usage (Implicit)\n\n* []() VUID-VkBufferDeviceAddressInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::BUFFER_DEVICE_ADDRESS_INFO`]\n\n* []() VUID-VkBufferDeviceAddressInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkBufferDeviceAddressInfo-buffer-parameter  \n  `buffer` **must** be a valid [`crate::vk::Buffer`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Buffer`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetBufferDeviceAddress`], [`crate::vk::PFN_vkGetBufferDeviceAddress`], [`crate::vk::PFN_vkGetBufferDeviceAddress`], [`crate::vk::PFN_vkGetBufferOpaqueCaptureAddress`], [`crate::vk::PFN_vkGetBufferOpaqueCaptureAddress`]\n"]
#[doc(alias = "VkBufferDeviceAddressInfoKHR")]
#[allow(non_camel_case_types)]
pub type BufferDeviceAddressInfoKHR = crate::vk1_2::BufferDeviceAddressInfo;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferDeviceAddressInfoKHR.html)) · Alias <br/> VkBufferDeviceAddressInfo - Structure specifying the buffer to query an address for\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::BufferDeviceAddressInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkBufferDeviceAddressInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkBuffer           buffer;\n} VkBufferDeviceAddressInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_buffer_device_address\ntypedef VkBufferDeviceAddressInfo VkBufferDeviceAddressInfoKHR;\n```\n\nor the equivalent\n\n```\n// Provided by VK_EXT_buffer_device_address\ntypedef VkBufferDeviceAddressInfo VkBufferDeviceAddressInfoEXT;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `buffer` specifies the buffer whose address is being queried.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkBufferDeviceAddressInfo-buffer-02600  \n   If `buffer` is non-sparse and was not created with the[`crate::vk::BufferCreateFlagBits::DEVICE_ADDRESS_CAPTURE_REPLAY`] flag, then it**must** be bound completely and contiguously to a single[`crate::vk::DeviceMemory`] object\n\n* []() VUID-VkBufferDeviceAddressInfo-buffer-02601  \n  `buffer` **must** have been created with[`crate::vk::BufferUsageFlagBits::SHADER_DEVICE_ADDRESS`]\n\nValid Usage (Implicit)\n\n* []() VUID-VkBufferDeviceAddressInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::BUFFER_DEVICE_ADDRESS_INFO`]\n\n* []() VUID-VkBufferDeviceAddressInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkBufferDeviceAddressInfo-buffer-parameter  \n  `buffer` **must** be a valid [`crate::vk::Buffer`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Buffer`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetBufferDeviceAddress`], [`crate::vk::PFN_vkGetBufferDeviceAddress`], [`crate::vk::PFN_vkGetBufferDeviceAddress`], [`crate::vk::PFN_vkGetBufferOpaqueCaptureAddress`], [`crate::vk::PFN_vkGetBufferOpaqueCaptureAddress`]\n"]
#[doc(alias = "VkBufferDeviceAddressInfoKHR")]
#[allow(non_camel_case_types)]
pub type BufferDeviceAddressInfoKHRBuilder<'a> = crate::vk1_2::BufferDeviceAddressInfoBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferOpaqueCaptureAddressCreateInfoKHR.html)) · Alias <br/> VkBufferOpaqueCaptureAddressCreateInfo - Request a specific address for a buffer\n[](#_c_specification)C Specification\n----------\n\nTo request a specific device address for a buffer, add a[`crate::vk::BufferOpaqueCaptureAddressCreateInfo`] structure to the `pNext`chain of the [`crate::vk::BufferCreateInfo`] structure.\nThe [`crate::vk::BufferOpaqueCaptureAddressCreateInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkBufferOpaqueCaptureAddressCreateInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    uint64_t           opaqueCaptureAddress;\n} VkBufferOpaqueCaptureAddressCreateInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_buffer_device_address\ntypedef VkBufferOpaqueCaptureAddressCreateInfo VkBufferOpaqueCaptureAddressCreateInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `opaqueCaptureAddress` is the opaque capture address requested for\n  the buffer.\n[](#_description)Description\n----------\n\nIf `opaqueCaptureAddress` is zero, no specific address is requested.\n\nIf `opaqueCaptureAddress` is not zero, then it **should** be an address\nretrieved from [`crate::vk::PFN_vkGetBufferOpaqueCaptureAddress`] for an identically\ncreated buffer on the same implementation.\n\nIf this structure is not present, it is as if `opaqueCaptureAddress` is\nzero.\n\nApps **should** avoid creating buffers with app-provided addresses and\nimplementation-provided addresses in the same process, to reduce the\nlikelihood of [`crate::vk::Result::ERROR_INVALID_OPAQUE_CAPTURE_ADDRESS`] errors.\n\n|   |Note<br/><br/>The expected usage for this is that a trace capture/replay tool will add the[`crate::vk::BufferCreateFlagBits::DEVICE_ADDRESS_CAPTURE_REPLAY`] flag to all buffers<br/>that use [`crate::vk::BufferUsageFlagBits::SHADER_DEVICE_ADDRESS`], and during capture<br/>will save the queried opaque device addresses in the trace.<br/>During replay, the buffers will be created specifying the original address<br/>so any address values stored in the trace data will remain valid.<br/><br/>Implementations are expected to separate such buffers in the GPU address<br/>space so normal allocations will avoid using these addresses.<br/>Apps/tools should avoid mixing app-provided and implementation-provided<br/>addresses for buffers created with[`crate::vk::BufferCreateFlagBits::DEVICE_ADDRESS_CAPTURE_REPLAY`], to avoid address<br/>space allocation conflicts.|\n|---|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage (Implicit)\n\n* []() VUID-VkBufferOpaqueCaptureAddressCreateInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::BUFFER_OPAQUE_CAPTURE_ADDRESS_CREATE_INFO`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`]\n"]
#[doc(alias = "VkBufferOpaqueCaptureAddressCreateInfoKHR")]
#[allow(non_camel_case_types)]
pub type BufferOpaqueCaptureAddressCreateInfoKHR = crate::vk1_2::BufferOpaqueCaptureAddressCreateInfo;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferOpaqueCaptureAddressCreateInfoKHR.html)) · Alias <br/> VkBufferOpaqueCaptureAddressCreateInfo - Request a specific address for a buffer\n[](#_c_specification)C Specification\n----------\n\nTo request a specific device address for a buffer, add a[`crate::vk::BufferOpaqueCaptureAddressCreateInfo`] structure to the `pNext`chain of the [`crate::vk::BufferCreateInfo`] structure.\nThe [`crate::vk::BufferOpaqueCaptureAddressCreateInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkBufferOpaqueCaptureAddressCreateInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    uint64_t           opaqueCaptureAddress;\n} VkBufferOpaqueCaptureAddressCreateInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_buffer_device_address\ntypedef VkBufferOpaqueCaptureAddressCreateInfo VkBufferOpaqueCaptureAddressCreateInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `opaqueCaptureAddress` is the opaque capture address requested for\n  the buffer.\n[](#_description)Description\n----------\n\nIf `opaqueCaptureAddress` is zero, no specific address is requested.\n\nIf `opaqueCaptureAddress` is not zero, then it **should** be an address\nretrieved from [`crate::vk::PFN_vkGetBufferOpaqueCaptureAddress`] for an identically\ncreated buffer on the same implementation.\n\nIf this structure is not present, it is as if `opaqueCaptureAddress` is\nzero.\n\nApps **should** avoid creating buffers with app-provided addresses and\nimplementation-provided addresses in the same process, to reduce the\nlikelihood of [`crate::vk::Result::ERROR_INVALID_OPAQUE_CAPTURE_ADDRESS`] errors.\n\n|   |Note<br/><br/>The expected usage for this is that a trace capture/replay tool will add the[`crate::vk::BufferCreateFlagBits::DEVICE_ADDRESS_CAPTURE_REPLAY`] flag to all buffers<br/>that use [`crate::vk::BufferUsageFlagBits::SHADER_DEVICE_ADDRESS`], and during capture<br/>will save the queried opaque device addresses in the trace.<br/>During replay, the buffers will be created specifying the original address<br/>so any address values stored in the trace data will remain valid.<br/><br/>Implementations are expected to separate such buffers in the GPU address<br/>space so normal allocations will avoid using these addresses.<br/>Apps/tools should avoid mixing app-provided and implementation-provided<br/>addresses for buffers created with[`crate::vk::BufferCreateFlagBits::DEVICE_ADDRESS_CAPTURE_REPLAY`], to avoid address<br/>space allocation conflicts.|\n|---|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage (Implicit)\n\n* []() VUID-VkBufferOpaqueCaptureAddressCreateInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::BUFFER_OPAQUE_CAPTURE_ADDRESS_CREATE_INFO`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`]\n"]
#[doc(alias = "VkBufferOpaqueCaptureAddressCreateInfoKHR")]
#[allow(non_camel_case_types)]
pub type BufferOpaqueCaptureAddressCreateInfoKHRBuilder<'a> = crate::vk1_2::BufferOpaqueCaptureAddressCreateInfoBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkMemoryOpaqueCaptureAddressAllocateInfoKHR.html)) · Alias <br/> VkMemoryOpaqueCaptureAddressAllocateInfo - Request a specific address for a memory allocation\n[](#_c_specification)C Specification\n----------\n\nTo request a specific device address for a memory allocation, add a[`crate::vk::MemoryOpaqueCaptureAddressAllocateInfo`] structure to the `pNext`chain of the [`crate::vk::MemoryAllocateInfo`] structure.\nThe [`crate::vk::MemoryOpaqueCaptureAddressAllocateInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkMemoryOpaqueCaptureAddressAllocateInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    uint64_t           opaqueCaptureAddress;\n} VkMemoryOpaqueCaptureAddressAllocateInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_buffer_device_address\ntypedef VkMemoryOpaqueCaptureAddressAllocateInfo VkMemoryOpaqueCaptureAddressAllocateInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `opaqueCaptureAddress` is the opaque capture address requested for\n  the memory allocation.\n[](#_description)Description\n----------\n\nIf `opaqueCaptureAddress` is zero, no specific address is requested.\n\nIf `opaqueCaptureAddress` is not zero, it **should** be an address\nretrieved from [`crate::vk::PFN_vkGetDeviceMemoryOpaqueCaptureAddress`] on an identically\ncreated memory allocation on the same implementation.\n\n|   |Note<br/><br/>In most cases, it is expected that a non-zero `opaqueAddress` is an<br/>address retrieved from [`crate::vk::PFN_vkGetDeviceMemoryOpaqueCaptureAddress`] on an<br/>identically created memory allocation.<br/>If this is not the case, it is likely that[`crate::vk::Result::ERROR_INVALID_OPAQUE_CAPTURE_ADDRESS`] errors will occur.<br/><br/>This is, however, not a strict requirement because trace capture/replay<br/>tools may need to adjust memory allocation parameters for imported memory.|\n|---|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nIf this structure is not present, it is as if `opaqueCaptureAddress` is\nzero.\n\nValid Usage (Implicit)\n\n* []() VUID-VkMemoryOpaqueCaptureAddressAllocateInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::MEMORY_OPAQUE_CAPTURE_ADDRESS_ALLOCATE_INFO`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`]\n"]
#[doc(alias = "VkMemoryOpaqueCaptureAddressAllocateInfoKHR")]
#[allow(non_camel_case_types)]
pub type MemoryOpaqueCaptureAddressAllocateInfoKHR = crate::vk1_2::MemoryOpaqueCaptureAddressAllocateInfo;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkMemoryOpaqueCaptureAddressAllocateInfoKHR.html)) · Alias <br/> VkMemoryOpaqueCaptureAddressAllocateInfo - Request a specific address for a memory allocation\n[](#_c_specification)C Specification\n----------\n\nTo request a specific device address for a memory allocation, add a[`crate::vk::MemoryOpaqueCaptureAddressAllocateInfo`] structure to the `pNext`chain of the [`crate::vk::MemoryAllocateInfo`] structure.\nThe [`crate::vk::MemoryOpaqueCaptureAddressAllocateInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkMemoryOpaqueCaptureAddressAllocateInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    uint64_t           opaqueCaptureAddress;\n} VkMemoryOpaqueCaptureAddressAllocateInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_buffer_device_address\ntypedef VkMemoryOpaqueCaptureAddressAllocateInfo VkMemoryOpaqueCaptureAddressAllocateInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `opaqueCaptureAddress` is the opaque capture address requested for\n  the memory allocation.\n[](#_description)Description\n----------\n\nIf `opaqueCaptureAddress` is zero, no specific address is requested.\n\nIf `opaqueCaptureAddress` is not zero, it **should** be an address\nretrieved from [`crate::vk::PFN_vkGetDeviceMemoryOpaqueCaptureAddress`] on an identically\ncreated memory allocation on the same implementation.\n\n|   |Note<br/><br/>In most cases, it is expected that a non-zero `opaqueAddress` is an<br/>address retrieved from [`crate::vk::PFN_vkGetDeviceMemoryOpaqueCaptureAddress`] on an<br/>identically created memory allocation.<br/>If this is not the case, it is likely that[`crate::vk::Result::ERROR_INVALID_OPAQUE_CAPTURE_ADDRESS`] errors will occur.<br/><br/>This is, however, not a strict requirement because trace capture/replay<br/>tools may need to adjust memory allocation parameters for imported memory.|\n|---|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nIf this structure is not present, it is as if `opaqueCaptureAddress` is\nzero.\n\nValid Usage (Implicit)\n\n* []() VUID-VkMemoryOpaqueCaptureAddressAllocateInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::MEMORY_OPAQUE_CAPTURE_ADDRESS_ALLOCATE_INFO`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`]\n"]
#[doc(alias = "VkMemoryOpaqueCaptureAddressAllocateInfoKHR")]
#[allow(non_camel_case_types)]
pub type MemoryOpaqueCaptureAddressAllocateInfoKHRBuilder<'a> = crate::vk1_2::MemoryOpaqueCaptureAddressAllocateInfoBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkDeviceMemoryOpaqueCaptureAddressInfoKHR.html)) · Alias <br/> VkDeviceMemoryOpaqueCaptureAddressInfo - Structure specifying the memory object to query an address for\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::DeviceMemoryOpaqueCaptureAddressInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkDeviceMemoryOpaqueCaptureAddressInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkDeviceMemory     memory;\n} VkDeviceMemoryOpaqueCaptureAddressInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_buffer_device_address\ntypedef VkDeviceMemoryOpaqueCaptureAddressInfo VkDeviceMemoryOpaqueCaptureAddressInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `memory` specifies the memory whose address is being queried.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkDeviceMemoryOpaqueCaptureAddressInfo-memory-03336  \n  `memory` **must** have been allocated with[`crate::vk::MemoryAllocateFlagBits::DEVICE_ADDRESS`]\n\nValid Usage (Implicit)\n\n* []() VUID-VkDeviceMemoryOpaqueCaptureAddressInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::DEVICE_MEMORY_OPAQUE_CAPTURE_ADDRESS_INFO`]\n\n* []() VUID-VkDeviceMemoryOpaqueCaptureAddressInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkDeviceMemoryOpaqueCaptureAddressInfo-memory-parameter  \n  `memory` **must** be a valid [`crate::vk::DeviceMemory`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DeviceMemory`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetDeviceMemoryOpaqueCaptureAddress`], [`crate::vk::PFN_vkGetDeviceMemoryOpaqueCaptureAddress`]\n"]
#[doc(alias = "VkDeviceMemoryOpaqueCaptureAddressInfoKHR")]
#[allow(non_camel_case_types)]
pub type DeviceMemoryOpaqueCaptureAddressInfoKHR = crate::vk1_2::DeviceMemoryOpaqueCaptureAddressInfo;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkDeviceMemoryOpaqueCaptureAddressInfoKHR.html)) · Alias <br/> VkDeviceMemoryOpaqueCaptureAddressInfo - Structure specifying the memory object to query an address for\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::DeviceMemoryOpaqueCaptureAddressInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkDeviceMemoryOpaqueCaptureAddressInfo {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkDeviceMemory     memory;\n} VkDeviceMemoryOpaqueCaptureAddressInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_buffer_device_address\ntypedef VkDeviceMemoryOpaqueCaptureAddressInfo VkDeviceMemoryOpaqueCaptureAddressInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `memory` specifies the memory whose address is being queried.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkDeviceMemoryOpaqueCaptureAddressInfo-memory-03336  \n  `memory` **must** have been allocated with[`crate::vk::MemoryAllocateFlagBits::DEVICE_ADDRESS`]\n\nValid Usage (Implicit)\n\n* []() VUID-VkDeviceMemoryOpaqueCaptureAddressInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::DEVICE_MEMORY_OPAQUE_CAPTURE_ADDRESS_INFO`]\n\n* []() VUID-VkDeviceMemoryOpaqueCaptureAddressInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkDeviceMemoryOpaqueCaptureAddressInfo-memory-parameter  \n  `memory` **must** be a valid [`crate::vk::DeviceMemory`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DeviceMemory`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetDeviceMemoryOpaqueCaptureAddress`], [`crate::vk::PFN_vkGetDeviceMemoryOpaqueCaptureAddress`]\n"]
#[doc(alias = "VkDeviceMemoryOpaqueCaptureAddressInfoKHR")]
#[allow(non_camel_case_types)]
pub type DeviceMemoryOpaqueCaptureAddressInfoKHRBuilder<'a> = crate::vk1_2::DeviceMemoryOpaqueCaptureAddressInfoBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetBufferOpaqueCaptureAddressKHR.html)) · Alias <br/> vkGetBufferOpaqueCaptureAddress - Query an opaque capture address of a buffer\n[](#_c_specification)C Specification\n----------\n\nTo query a 64-bit buffer opaque capture address, call:\n\n```\n// Provided by VK_VERSION_1_2\nuint64_t vkGetBufferOpaqueCaptureAddress(\n    VkDevice                                    device,\n    const VkBufferDeviceAddressInfo*            pInfo);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_buffer_device_address\nuint64_t vkGetBufferOpaqueCaptureAddressKHR(\n    VkDevice                                    device,\n    const VkBufferDeviceAddressInfo*            pInfo);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that the buffer was created on.\n\n* `pInfo` is a pointer to a [`crate::vk::BufferDeviceAddressInfo`] structure\n  specifying the buffer to retrieve an address for.\n[](#_description)Description\n----------\n\nThe 64-bit return value is an opaque capture address of the start of`pInfo->buffer`.\n\nIf the buffer was created with a non-zero value of[`crate::vk::BufferOpaqueCaptureAddressCreateInfo::opaque_capture_address`] the\nreturn value **must** be the same address.\n\nValid Usage\n\n* []() VUID-vkGetBufferOpaqueCaptureAddress-None-03326  \n   The [bufferDeviceAddress](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddress) feature **must**be enabled\n\n* []() VUID-vkGetBufferOpaqueCaptureAddress-device-03327  \n   If `device` was created with multiple physical devices, then the[bufferDeviceAddressMultiDevice](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddressMultiDevice)feature **must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetBufferOpaqueCaptureAddress-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetBufferOpaqueCaptureAddress-pInfo-parameter  \n  `pInfo` **must** be a valid pointer to a valid [`crate::vk::BufferDeviceAddressInfo`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::BufferDeviceAddressInfo`], [`crate::vk::Device`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetBufferOpaqueCaptureAddressKHR = crate::vk1_2::PFN_vkGetBufferOpaqueCaptureAddress;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetBufferDeviceAddressKHR.html)) · Alias <br/> vkGetBufferDeviceAddress - Query an address of a buffer\n[](#_c_specification)C Specification\n----------\n\nTo query a 64-bit buffer device address value through which buffer memory**can** be accessed in a shader, call:\n\n```\n// Provided by VK_VERSION_1_2\nVkDeviceAddress vkGetBufferDeviceAddress(\n    VkDevice                                    device,\n    const VkBufferDeviceAddressInfo*            pInfo);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_buffer_device_address\nVkDeviceAddress vkGetBufferDeviceAddressKHR(\n    VkDevice                                    device,\n    const VkBufferDeviceAddressInfo*            pInfo);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_EXT_buffer_device_address\nVkDeviceAddress vkGetBufferDeviceAddressEXT(\n    VkDevice                                    device,\n    const VkBufferDeviceAddressInfo*            pInfo);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that the buffer was created on.\n\n* `pInfo` is a pointer to a [`crate::vk::BufferDeviceAddressInfo`] structure\n  specifying the buffer to retrieve an address for.\n[](#_description)Description\n----------\n\nThe 64-bit return value is an address of the start of `pInfo->buffer`.\nThe address range starting at this value and whose size is the size of the\nbuffer **can** be used in a shader to access the memory bound to that buffer,\nusing the`SPV_KHR_physical_storage_buffer` extension\nor the equivalent`SPV_EXT_physical_storage_buffer` extension\nand the `PhysicalStorageBuffer` storage class.\nFor example, this value **can** be stored in a uniform buffer, and the shader**can** read the value from the uniform buffer and use it to do a dependent\nread/write to this buffer.\nA value of zero is reserved as a “null” pointer and **must** not be returned\nas a valid buffer device address.\nAll loads, stores, and atomics in a shader through`PhysicalStorageBuffer` pointers **must** access addresses in the address\nrange of some buffer.\n\nIf the buffer was created with a non-zero value of[`crate::vk::BufferOpaqueCaptureAddressCreateInfo::opaque_capture_address`]or[`crate::vk::BufferDeviceAddressCreateInfoEXT::device_address`]the return value will be the same address that was returned at capture time.\n\nValid Usage\n\n* []() VUID-vkGetBufferDeviceAddress-bufferDeviceAddress-03324  \n   The [bufferDeviceAddress](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddress) or[[`crate::vk::PhysicalDeviceBufferDeviceAddressFeaturesEXT`]::`bufferDeviceAddress`](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddressEXT)feature **must** be enabled\n\n* []() VUID-vkGetBufferDeviceAddress-device-03325  \n   If `device` was created with multiple physical devices, then the[bufferDeviceAddressMultiDevice](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddressMultiDevice)or[[`crate::vk::PhysicalDeviceBufferDeviceAddressFeaturesEXT`]::`bufferDeviceAddressMultiDevice`](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddressMultiDeviceEXT)feature **must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetBufferDeviceAddress-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetBufferDeviceAddress-pInfo-parameter  \n  `pInfo` **must** be a valid pointer to a valid [`crate::vk::BufferDeviceAddressInfo`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::BufferDeviceAddressInfo`], [`crate::vk::Device`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetBufferDeviceAddressKHR = crate::vk1_2::PFN_vkGetBufferDeviceAddress;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetDeviceMemoryOpaqueCaptureAddressKHR.html)) · Alias <br/> vkGetDeviceMemoryOpaqueCaptureAddress - Query an opaque capture address of a memory object\n[](#_c_specification)C Specification\n----------\n\nTo query a 64-bit opaque capture address value from a memory object, call:\n\n```\n// Provided by VK_VERSION_1_2\nuint64_t vkGetDeviceMemoryOpaqueCaptureAddress(\n    VkDevice                                    device,\n    const VkDeviceMemoryOpaqueCaptureAddressInfo* pInfo);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_buffer_device_address\nuint64_t vkGetDeviceMemoryOpaqueCaptureAddressKHR(\n    VkDevice                                    device,\n    const VkDeviceMemoryOpaqueCaptureAddressInfo* pInfo);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that the memory object was allocated\n  on.\n\n* `pInfo` is a pointer to a[`crate::vk::DeviceMemoryOpaqueCaptureAddressInfo`] structure specifying the\n  memory object to retrieve an address for.\n[](#_description)Description\n----------\n\nThe 64-bit return value is an opaque address representing the start of`pInfo->memory`.\n\nIf the memory object was allocated with a non-zero value of[`crate::vk::MemoryOpaqueCaptureAddressAllocateInfo::opaque_capture_address`],\nthe return value **must** be the same address.\n\n|   |Note<br/><br/>The expected usage for these opaque addresses is only for trace<br/>capture/replay tools to store these addresses in a trace and subsequently<br/>specify them during replay.|\n|---|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage\n\n* []() VUID-vkGetDeviceMemoryOpaqueCaptureAddress-None-03334  \n   The [bufferDeviceAddress](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddress) feature **must**be enabled\n\n* []() VUID-vkGetDeviceMemoryOpaqueCaptureAddress-device-03335  \n   If `device` was created with multiple physical devices, then the[bufferDeviceAddressMultiDevice](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddressMultiDevice)feature **must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetDeviceMemoryOpaqueCaptureAddress-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetDeviceMemoryOpaqueCaptureAddress-pInfo-parameter  \n  `pInfo` **must** be a valid pointer to a valid [`crate::vk::DeviceMemoryOpaqueCaptureAddressInfo`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::DeviceMemoryOpaqueCaptureAddressInfo`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetDeviceMemoryOpaqueCaptureAddressKHR = crate::vk1_2::PFN_vkGetDeviceMemoryOpaqueCaptureAddress;
#[doc = "Provided by [`crate::extensions::khr_buffer_device_address`]"]
impl crate::vk1_0::BufferCreateFlagBits {
    pub const DEVICE_ADDRESS_CAPTURE_REPLAY_KHR: Self = Self::DEVICE_ADDRESS_CAPTURE_REPLAY;
}
#[doc = "Provided by [`crate::extensions::khr_buffer_device_address`]"]
impl crate::vk1_0::BufferUsageFlagBits {
    pub const SHADER_DEVICE_ADDRESS_KHR: Self = Self::SHADER_DEVICE_ADDRESS;
}
#[doc = "Provided by [`crate::extensions::khr_buffer_device_address`]"]
impl crate::vk1_0::Result {
    pub const ERROR_INVALID_OPAQUE_CAPTURE_ADDRESS_KHR: Self = Self::ERROR_INVALID_OPAQUE_CAPTURE_ADDRESS;
}
#[doc = "Provided by [`crate::extensions::khr_buffer_device_address`]"]
impl crate::vk1_0::StructureType {
    pub const PHYSICAL_DEVICE_BUFFER_DEVICE_ADDRESS_FEATURES_KHR: Self = Self::PHYSICAL_DEVICE_BUFFER_DEVICE_ADDRESS_FEATURES;
    pub const BUFFER_DEVICE_ADDRESS_INFO_KHR: Self = Self::BUFFER_DEVICE_ADDRESS_INFO;
    pub const BUFFER_OPAQUE_CAPTURE_ADDRESS_CREATE_INFO_KHR: Self = Self::BUFFER_OPAQUE_CAPTURE_ADDRESS_CREATE_INFO;
    pub const MEMORY_OPAQUE_CAPTURE_ADDRESS_ALLOCATE_INFO_KHR: Self = Self::MEMORY_OPAQUE_CAPTURE_ADDRESS_ALLOCATE_INFO;
    pub const DEVICE_MEMORY_OPAQUE_CAPTURE_ADDRESS_INFO_KHR: Self = Self::DEVICE_MEMORY_OPAQUE_CAPTURE_ADDRESS_INFO;
}
#[doc = "Provided by [`crate::extensions::khr_buffer_device_address`]"]
impl crate::vk1_1::MemoryAllocateFlagBits {
    pub const DEVICE_ADDRESS_KHR: Self = Self::DEVICE_ADDRESS;
    pub const DEVICE_ADDRESS_CAPTURE_REPLAY_KHR: Self = Self::DEVICE_ADDRESS_CAPTURE_REPLAY;
}
#[doc = "Provided by [`crate::extensions::khr_buffer_device_address`]"]
impl crate::DeviceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetBufferOpaqueCaptureAddressKHR.html)) · Function <br/> vkGetBufferOpaqueCaptureAddress - Query an opaque capture address of a buffer\n[](#_c_specification)C Specification\n----------\n\nTo query a 64-bit buffer opaque capture address, call:\n\n```\n// Provided by VK_VERSION_1_2\nuint64_t vkGetBufferOpaqueCaptureAddress(\n    VkDevice                                    device,\n    const VkBufferDeviceAddressInfo*            pInfo);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_buffer_device_address\nuint64_t vkGetBufferOpaqueCaptureAddressKHR(\n    VkDevice                                    device,\n    const VkBufferDeviceAddressInfo*            pInfo);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that the buffer was created on.\n\n* `pInfo` is a pointer to a [`crate::vk::BufferDeviceAddressInfo`] structure\n  specifying the buffer to retrieve an address for.\n[](#_description)Description\n----------\n\nThe 64-bit return value is an opaque capture address of the start of`pInfo->buffer`.\n\nIf the buffer was created with a non-zero value of[`crate::vk::BufferOpaqueCaptureAddressCreateInfo::opaque_capture_address`] the\nreturn value **must** be the same address.\n\nValid Usage\n\n* []() VUID-vkGetBufferOpaqueCaptureAddress-None-03326  \n   The [bufferDeviceAddress](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddress) feature **must**be enabled\n\n* []() VUID-vkGetBufferOpaqueCaptureAddress-device-03327  \n   If `device` was created with multiple physical devices, then the[bufferDeviceAddressMultiDevice](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddressMultiDevice)feature **must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetBufferOpaqueCaptureAddress-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetBufferOpaqueCaptureAddress-pInfo-parameter  \n  `pInfo` **must** be a valid pointer to a valid [`crate::vk::BufferDeviceAddressInfo`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::BufferDeviceAddressInfo`], [`crate::vk::Device`]\n"]
    #[doc(alias = "vkGetBufferOpaqueCaptureAddressKHR")]
    pub unsafe fn get_buffer_opaque_capture_address_khr(&self, info: &crate::vk1_2::BufferDeviceAddressInfo) -> u64 {
        let _function = self.get_buffer_opaque_capture_address_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(self.handle, info as _);
        _return
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetBufferDeviceAddressKHR.html)) · Function <br/> vkGetBufferDeviceAddress - Query an address of a buffer\n[](#_c_specification)C Specification\n----------\n\nTo query a 64-bit buffer device address value through which buffer memory**can** be accessed in a shader, call:\n\n```\n// Provided by VK_VERSION_1_2\nVkDeviceAddress vkGetBufferDeviceAddress(\n    VkDevice                                    device,\n    const VkBufferDeviceAddressInfo*            pInfo);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_buffer_device_address\nVkDeviceAddress vkGetBufferDeviceAddressKHR(\n    VkDevice                                    device,\n    const VkBufferDeviceAddressInfo*            pInfo);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_EXT_buffer_device_address\nVkDeviceAddress vkGetBufferDeviceAddressEXT(\n    VkDevice                                    device,\n    const VkBufferDeviceAddressInfo*            pInfo);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that the buffer was created on.\n\n* `pInfo` is a pointer to a [`crate::vk::BufferDeviceAddressInfo`] structure\n  specifying the buffer to retrieve an address for.\n[](#_description)Description\n----------\n\nThe 64-bit return value is an address of the start of `pInfo->buffer`.\nThe address range starting at this value and whose size is the size of the\nbuffer **can** be used in a shader to access the memory bound to that buffer,\nusing the`SPV_KHR_physical_storage_buffer` extension\nor the equivalent`SPV_EXT_physical_storage_buffer` extension\nand the `PhysicalStorageBuffer` storage class.\nFor example, this value **can** be stored in a uniform buffer, and the shader**can** read the value from the uniform buffer and use it to do a dependent\nread/write to this buffer.\nA value of zero is reserved as a “null” pointer and **must** not be returned\nas a valid buffer device address.\nAll loads, stores, and atomics in a shader through`PhysicalStorageBuffer` pointers **must** access addresses in the address\nrange of some buffer.\n\nIf the buffer was created with a non-zero value of[`crate::vk::BufferOpaqueCaptureAddressCreateInfo::opaque_capture_address`]or[`crate::vk::BufferDeviceAddressCreateInfoEXT::device_address`]the return value will be the same address that was returned at capture time.\n\nValid Usage\n\n* []() VUID-vkGetBufferDeviceAddress-bufferDeviceAddress-03324  \n   The [bufferDeviceAddress](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddress) or[[`crate::vk::PhysicalDeviceBufferDeviceAddressFeaturesEXT`]::`bufferDeviceAddress`](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddressEXT)feature **must** be enabled\n\n* []() VUID-vkGetBufferDeviceAddress-device-03325  \n   If `device` was created with multiple physical devices, then the[bufferDeviceAddressMultiDevice](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddressMultiDevice)or[[`crate::vk::PhysicalDeviceBufferDeviceAddressFeaturesEXT`]::`bufferDeviceAddressMultiDevice`](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddressMultiDeviceEXT)feature **must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetBufferDeviceAddress-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetBufferDeviceAddress-pInfo-parameter  \n  `pInfo` **must** be a valid pointer to a valid [`crate::vk::BufferDeviceAddressInfo`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::BufferDeviceAddressInfo`], [`crate::vk::Device`]\n"]
    #[doc(alias = "vkGetBufferDeviceAddressKHR")]
    pub unsafe fn get_buffer_device_address_khr(&self, info: &crate::vk1_2::BufferDeviceAddressInfo) -> crate::vk1_0::DeviceAddress {
        let _function = self.get_buffer_device_address_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(self.handle, info as _);
        _return
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetDeviceMemoryOpaqueCaptureAddressKHR.html)) · Function <br/> vkGetDeviceMemoryOpaqueCaptureAddress - Query an opaque capture address of a memory object\n[](#_c_specification)C Specification\n----------\n\nTo query a 64-bit opaque capture address value from a memory object, call:\n\n```\n// Provided by VK_VERSION_1_2\nuint64_t vkGetDeviceMemoryOpaqueCaptureAddress(\n    VkDevice                                    device,\n    const VkDeviceMemoryOpaqueCaptureAddressInfo* pInfo);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_buffer_device_address\nuint64_t vkGetDeviceMemoryOpaqueCaptureAddressKHR(\n    VkDevice                                    device,\n    const VkDeviceMemoryOpaqueCaptureAddressInfo* pInfo);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that the memory object was allocated\n  on.\n\n* `pInfo` is a pointer to a[`crate::vk::DeviceMemoryOpaqueCaptureAddressInfo`] structure specifying the\n  memory object to retrieve an address for.\n[](#_description)Description\n----------\n\nThe 64-bit return value is an opaque address representing the start of`pInfo->memory`.\n\nIf the memory object was allocated with a non-zero value of[`crate::vk::MemoryOpaqueCaptureAddressAllocateInfo::opaque_capture_address`],\nthe return value **must** be the same address.\n\n|   |Note<br/><br/>The expected usage for these opaque addresses is only for trace<br/>capture/replay tools to store these addresses in a trace and subsequently<br/>specify them during replay.|\n|---|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage\n\n* []() VUID-vkGetDeviceMemoryOpaqueCaptureAddress-None-03334  \n   The [bufferDeviceAddress](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddress) feature **must**be enabled\n\n* []() VUID-vkGetDeviceMemoryOpaqueCaptureAddress-device-03335  \n   If `device` was created with multiple physical devices, then the[bufferDeviceAddressMultiDevice](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-bufferDeviceAddressMultiDevice)feature **must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetDeviceMemoryOpaqueCaptureAddress-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetDeviceMemoryOpaqueCaptureAddress-pInfo-parameter  \n  `pInfo` **must** be a valid pointer to a valid [`crate::vk::DeviceMemoryOpaqueCaptureAddressInfo`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::DeviceMemoryOpaqueCaptureAddressInfo`]\n"]
    #[doc(alias = "vkGetDeviceMemoryOpaqueCaptureAddressKHR")]
    pub unsafe fn get_device_memory_opaque_capture_address_khr(&self, info: &crate::vk1_2::DeviceMemoryOpaqueCaptureAddressInfo) -> u64 {
        let _function = self.get_device_memory_opaque_capture_address_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(self.handle, info as _);
        _return
    }
}
